<?php
namespace Nc\Ncregisterplus\Controller;


/**
 * An frontend user create controller
 */
class FeuserplusCreateController extends FeuserCreateController {

    /**
     * Form action
     *
     * @return void
     */
    public function formAction()
    {
        /** @var \TYPO3\CMS\Extbase\Mvc\Request $originalRequest */
        $originalRequest = $this->request->getOriginalRequest();
        if ($this->request->hasArgument('user')
            || ($originalRequest !== null && $originalRequest->hasArgument('user'))
        ) {
            $userData = $this->request->hasArgument('user') ?
                $this->request->getArgument('user') :
                $originalRequest->getArgument('user');
            if (isset($userData['uid'])) {
                unset($userData['uid']);
            }

            /** @var \TYPO3\CMS\Extbase\Property\PropertyMapper $propertyMapper */
            $propertyMapper = $this->objectManager->get('TYPO3\\CMS\\Extbase\\Property\\PropertyMapper');
            $user = $propertyMapper->convert($userData, 'Evoweb\\SfRegister\\Domain\\Model\\FrontendUser');
            $user = $this->moveTempFile($user);
        } else {
            /** @var \Evoweb\SfRegister\Domain\Model\FrontendUser $user */
            $user = $this->objectManager->get('Evoweb\\SfRegister\\Domain\\Model\\FrontendUser');
        }

        if ($originalRequest !== null && $originalRequest->hasArgument('temporaryImage')) {
            $this->view->assign('temporaryImage', $originalRequest->getArgument('temporaryImage'));
        }

        $this->signalSlotDispatcher->dispatch(__CLASS__, __FUNCTION__, array(
                'user' => &$user,
                'settings' => $this->settings,
            ));

        $this->view->assign('user', $user);
    }
}
